<?php

namespace ID3\Bases;

class MainInstance extends Plugin {
    
    function __construct($namespace){
        parent::__construct($namespace);

        $this->addStyle('public');
        $this->addScript('public');

        $this->addAction('wp_enqueue_scripts','registerScripts');
        $this->addAction('wp_enqueue_scripts','registerStyles');

        $this->addAction('admin_enqueue_scripts','registerAdminScripts');

        $this->init();
    }


    function addStyle($path,$min=true,$timestamp=true){
        $absFilePath = '';
        if(strpos($path,'http')===0){
            $absFilePath = $path;
        }
        else{
            $filename = 'styles/' . $path . ($min ? '.min' : '') . '.css';
            if(!file_exists($this->dir . $filename)) return;
            $absFilePath = '/' . $this->url . $filename . ($timestamp ? '?v=' . filemtime($this->dir . $filename) : '');
        }
        if($this->styles == null) $this->styles = [];
        $this->styles[] = [
            'key' => $this->key . '-' . basename($path),
            'path' => $absFilePath
        ];
    }
    function addScript($path,$min=true,$timestamp=true){
        $absFilePath = '';
        if(strpos($path,'http')===0){
            $absFilePath = $path;
        }
        else{
            $filename = 'scripts/' . $path . ($min ? '.min' : '') . '.js';
            if(!file_exists($this->dir . $filename)) return;
            $absFilePath = '/' . $this->url . $filename . ($timestamp ? '?v=' . filemtime($this->dir . $filename) : '');
        }
        if($this->scripts == null) $this->scripts = [];
        $this->scripts[] = [
            'key' => $this->key . '-' . basename($path),
            'path' => $absFilePath
        ];
    }


}
