<?php

namespace ID3\Bases;

class Module{

    public $_settings = null;
    public $_module_path = '';
    public $namespace = '';

    public function init($namespace){
        $this->namespace = $namespace;    
        $this->key       = constant($namespace . '\KEY');
    }

    public function register_actions(){
        add_action('admin_footer', function(){
            if(0 == did_action('id3/framework/render_scripts')){
                do_action('id3/framework/render_scripts');
            }
        });
    }
    public function register_filters(){}
    
    public function includes(){}

    public function get_admin_script_depends() {
    	return [ ];
    }

    public function get_admin_style_depends() {
    	return [ ];
    }

    public function get_script_depends() {
    	return [ ];
    }

    public function get_style_depends() {
    	return [ ];
    }

    public function register_locales(){
        if(file_exists($this->_module_path . '/locales/')){
            add_filter('id3-locale-file-paths', array($this,'add_locale_files'),5,1);
        }
    }

    
    public function add_locale_files($files){
        $lTwoLetterLocale = si_get_locale();
        if(file_exists($this->_module_path . "/locales/module.{$lTwoLetterLocale}.js")){
            $files[] = $this->_module_path . "/locales/module.{$lTwoLetterLocale}.js";
        }

        return $files;
    }

    public function getSettings(){
        if($this->_settings == null){
            $this->_settings = \ID3\Settings::get($this->key);
        }

        return $this->_settings;
    }
}