<?php
namespace  ID3\Framework;

class Block extends \ID3\Bases\Block{

    public $category = 'ID-3 Framework';

    function __construct(){
        parent::__construct(__NAMESPACE__);

        add_action( 'admin_head', [$this, 'registerGlobalStyles'] );
        //add_filter('admin_body_class', [$this, 'addAdminBodyClass']);
    }

    function registerGlobalStyles(){

        $this->loadSettings();

        if(!is_array($this->settings)){
            $palette = new ColorPaletteBuilder($this->settings->color_palette,'.block-editor');
            $palette->generateStyle();
        }
    }

    function addAdminBodyClass($classes) { 
        //get current page
        global $pagenow;

        //check if the current page is post.php and if the post parameteris set
        if ( $pagenow ==='post.php' && isset($_GET['post']) ) {
            //get the post type via the post id from the URL
            // $postType = get_post_type( $_GET['post']);
            //append the new class
            $classes .= 'id3-color-primary id3-color-apply-bg';
        } 
        //next check if this is a new post
        elseif ( $pagenow ==='post-new.php' )  {
            //check if the post_type parameter is set
            $classes .= 'id3-color-primary id3-color-apply-bg';

            // if(isset($_GET['post_type'])) {
            //     //in this case you can get the post_type directly from the URL
            //     $classes .= 'single-' . urldecode($_GET['post_type']);
            // } else {
            //     //if post_type is not set, a 'post' is being created
            //     $classes .= 'single-post';
            // }


        }
        return $classes;
    }
}

new Block();