<?php
namespace ID3;

if(!function_exists('\ID3\isNullOrEmpty')){
    function isNullOrEmpty($data){
        if($data === null) return true;
        if(!isset($data)) return true;

        if(is_array($data) && count($data)==0) return true;
        if($data === '') return true;
        return false;
    }
}

if(!function_exists('\ID3\log')){
    function log(...$data){
        echo('<pre>');
        foreach($data as $value){
            echo($data . PHP_EOL);
        }
        echo('</pre>');
    }
}
if(!function_exists('\ID3\debug')){
    function debug(...$data){
        echo('<pre>');
        foreach($data as $value){
            var_dump($value);
        }
        echo('</pre>');
    }
}

if(!function_exists('\ID3\is_plugin_active')){
    function is_plugin_active($plugin_name){
        $plugins = get_option( 'active_plugins', [] );
        foreach ($plugins as $value) {
            if(strpos($value, $plugin_name) !== false) return true;
        }

        if ( ! is_multisite() ) return false;


        $plugins = get_site_option( 'active_sitewide_plugins' );
        foreach ($plugins as $value) {
            if(strpos($value, $plugin_name) !== false) return true;
        }
        return false;
    }
}

if ( ! function_exists('\ID3\write_log')) {
    function write_log ( $log,...$params )  {
        if ( is_array( $log ) || is_object( $log ) ) {
            error_log( print_r( $log, true ) );
        } else {
            error_log( $log );
        }

        foreach ($params as $param) {
            if ( is_array( $param ) || is_object( $param ) ) {
                error_log( print_r( $param, true ) );
            } else {
                error_log( $param );
            } 
        }
    }
 }