<?php
namespace ID3\Framework;
    
class Bootstrap{
    private $_namespace;

    function __construct($namespace){
        $this->_namespace = $namespace;
        $dirPath = plugin_dir_path( __FILE__ );
        $pluginFile = constant($namespace . '\PLUGIN');
       
        // Plugin description
        if(!defined($namespace . '\DESC')){
            try {
                $pluginInfo = get_plugin_data($pluginFile);
                $description = trim(substr($pluginInfo['Description'], 0 ,strpos($pluginInfo['Description'],'<cite>')));
                define($namespace . '\DESC', $description);
            } catch (\Throwable $th) {
                //throw $th;
            }
        }
        
        $bootstrapped = require_once( $dirPath . 'wp.helpers.php');
        require_once( $dirPath . 'class.settings.php');
        require_once( $dirPath . 'class.base.module.php');
        require_once( $dirPath . 'class.base.plugin.php');
        require_once( $dirPath . 'class.base.rest.php');
        require_once( $dirPath . 'class.base.shortcode.php');
        require_once( $dirPath . 'class.base.block.php');

        add_action('id3/bootstrap/admin', [$this,'load_admin']);

        if ( is_admin() || is_network_admin() ) {
            // require_once( $dirPath . 'class.base.admin.php');
            
            // require_once( $dirPath . 'class.update.php');
            // //new GitHubPluginUpdater( constant($namespace . '\PLUGIN'), constant($namespace . '\GIT_USR'), constant($namespace . '\GIT_PROJECT_NAME'), constant($namespace . '\GIT_ACCESS_TOKEN') );
            // new \ID3\Framework\Updater(constant($namespace . '\PLUGIN'));

            // require_once(constant($namespace . '\PLUGIN_DIR') . 'core/class.admin.php');
            do_action('id3/bootstrap/admin', true);
        }

        require_once( $dirPath . 'class.base.main.php');
        require_once(constant($namespace . '\PLUGIN_DIR') . 'core/class.main.php');

        if($bootstrapped!==true){
            // Init REST api
            add_action( 'rest_api_init', [\ID3\Rest::instance() , 'init' ] );
            add_action( 'init', [\ID3\ShortcodeEngine::instance(), 'init'] );
        }
    }

    function load_admin($include_update=false){
        $dirPath = plugin_dir_path( __FILE__ );
        
        require_once( $dirPath . 'class.base.admin.php');

        if($include_update){
            require_once( $dirPath . 'class.update.php');
            //new GitHubPluginUpdater( constant($namespace . '\PLUGIN'), constant($namespace . '\GIT_USR'), constant($namespace . '\GIT_PROJECT_NAME'), constant($namespace . '\GIT_ACCESS_TOKEN') );
            new \ID3\Framework\Updater(constant($this->_namespace . '\PLUGIN'));
        }
        require_once(constant($this->_namespace . '\PLUGIN_DIR') . 'core/class.admin.php');
    }
}

