<?php
/*
Plugin Name: ID-3 Ecosystem framework
Plugin URI: https://id-3.net
Description: Framework to enable the ID-3 ecosystem
Version: 0.1.37
Author: ID-3 Innovations
Author URI: https://id-3.net
License: GPLv2 or later
Text Domain: id3-boot
*/

// Setup the main namespace for the plugin. 
// It should be ID3\Your_plugin_unique_key
namespace ID3\Framework;




// GLOBAL CONSTANTS
// Change the following constants to match your plugin definition
//

// Plugin name
define(__NAMESPACE__ . '\NAME',             'Framework');  

// // Plugin version
define(__NAMESPACE__ . '\VERSION',          '0.1.37');    

// // Plugin description
define(__NAMESPACE__ . '\DESC',             'ID-3 ecosystem\'s framework and shared components');

define(__NAMESPACE__ . '\COLOR',            '#888888');
       
// Text domain       
define(__NAMESPACE__ . '\TDOM',             'id3-frwk');

// Minium required Wordpress version
define(__NAMESPACE__ . '\MIN_WP_VERSION',   '4.0');

// Root file
define(__NAMESPACE__ . '\PLUGIN',            __FILE__);

// Root folder
define(__NAMESPACE__ . '\PLUGIN_DIR',                           
                            str_replace('\\', '/', plugin_dir_path( __FILE__ ) ));    

// Root Url folder
define(__NAMESPACE__ . '\PLUGIN_URL',                           
                            str_replace(str_replace('\\', '/', ABSPATH),'', namespace\PLUGIN_DIR));

// Plugin key
define(__NAMESPACE__ . '\KEY',             strtolower(pathinfo(__FILE__)['filename']) );

define(__NAMESPACE__ . '\ENABLE_LOG',      FALSE);

// Bootstap the plugin
require_once( namespace\PLUGIN_DIR . '/core/functions.php' );
require_once( namespace\PLUGIN_DIR . '/core/index.php' );
add_action( 'plugins_loaded', function(){

    new \ID3\Framework\Bootstrap(__NAMESPACE__);

}, 5 );


load_default_textdomain();

