var id3Plugin = angular.module('id3Plugin', ['ngRoute','ngMaterial','ngAnimate', 'ngMessages','ngSanitize','ui.sortable','angularMoment']);


id3Plugin
.config(function ($routeProvider, $mdThemingProvider, $httpProvider, $mdDateLocaleProvider, $mdAriaProvider,$animateProvider) {
    $animateProvider.classNameFilter(/angular-animate/);
    // disable aria warnings (aka aria-label warning of hell)
    $mdAriaProvider.disableWarnings();

    // Theming
    $mdThemingProvider.theme('default')
        .primaryPalette('orange')
        .accentPalette('orange');

    $mdThemingProvider.theme('docs-dark', 'default')
        .primaryPalette('blue')
        .dark();

    
    // Example of a French localization.
    console.log('$mdDateLocaleProvider.months', $mdDateLocaleProvider);
        const lMomentLocaleData = moment.localeData();
        $mdDateLocaleProvider.months = lMomentLocaleData._months;
        $mdDateLocaleProvider.shortMonths = lMomentLocaleData._monthsShort;
        $mdDateLocaleProvider.days = lMomentLocaleData._weekdays;
        $mdDateLocaleProvider.shortDays = lMomentLocaleData._weekdaysShort;
        /*
        // Can change week display to start on Monday.
        $mdDateLocaleProvider.firstDayOfWeek = 1;

        // Optional.
        $mdDateLocaleProvider.dates = [1, 2, 3, 4, 5, 6, ...];
        */

        // Example uses moment.js to parse and format dates.
        $mdDateLocaleProvider.parseDate = function(dateString) {
        var m = moment(dateString, 'L', true);
        return m.isValid() ? m.toDate() : new Date(NaN);
        };

        $mdDateLocaleProvider.formatDate = function(date) {
        var m = moment(date);
        return m.isValid() ? m.format('L') : '';
        };

        /*
        // Allow only a day and month to be specified.
        // This is required if using the 'M/D' format with moment.js.
        $mdDateLocaleProvider.isDateComplete = function(dateString) {
        dateString = dateString.trim();

        // Look for two chunks of content (either numbers or text) separated by delimiters.
        var re = /^(([a-zA-Z]{3,}|[0-9]{1,4})([ .,]+|[/-]))([a-zA-Z]{3,}|[0-9]{1,4})/;
        return re.test(dateString);
        };

        $mdDateLocaleProvider.monthHeaderFormatter = function(date) {
        return myShortMonths[date.getMonth()] + ' ' + date.getFullYear();
        };

        // In addition to date display, date components also need localized messages
        // for aria-labels for screen-reader users.

        $mdDateLocaleProvider.weekNumberFormatter = function(weekNumber) {
        return 'Semaine ' + weekNumber;
        };
        */
        $mdDateLocaleProvider.msgCalendar = 'Calendar'.translate();
        $mdDateLocaleProvider.msgOpenCalendar = 'Open calendar'.translate();
        /*
        // You can also set when your calendar begins and ends.
        $mdDateLocaleProvider.firstRenderableDate = new Date(1776, 6, 4);
        $mdDateLocaleProvider.lastRenderableDate = new Date(2012, 11, 21);
        */
    
});