id3Plugin
.controller('fwColorPickerDialogCtrl', function($scope, $rootScope,$timeout, $q, $element, $id3IO, $id3UI){
    $scope.color = {}
    $scope.original = {}
    $scope.options = {};
    $scope.colorPicker = {};
    $scope.paletteModes = [
        {key: 'hsl', label: 'HSL', selected:true},
        {key: 'rgb', label: 'RGB'}
    ];
    $scope.dialogOptions.actions = [
        {label: 'OK', primary:true, action: function(){ 
            // $scope.addColorLog($scope.color);

            // const lResult = $scope.colorToStr($scope.color);
            // console.log('fwColorPickerCtrl/OK',lResult, $scope.color);
            const lResult = ($scope.colorPicker.color[$scope.options.returnType] !== undefined) ? $scope.colorPicker.color[$scope.options.returnType] : $scope.colorPicker.color.hexString;
            console.log('fwColorPickerCtrl/OK',lResult,$scope.colorPicker);
            $scope.closeAndReturn(lResult); 
        } }
    ];

    $scope.init = function($params){
        $scope.options = Object.assign({
            returnType: 'hsl'
        },$params.options);

        $q.all([
            $id3IO.addScript('iro-color-lib','https://cdn.jsdelivr.net/npm/@jaames/iro@5'),
            $id3UI.waitFor('#iro-color-picker',$element[0])
        ])
        .then(_ => {
            $scope.original = new iro.Color($params.color || '#000');

            $scope.colorPicker = new iro.ColorPicker("#iro-color-picker", {
                // Set the size of the color picker
                width: 320,
                // Set the initial color to pure red
                color: $params.color || '#f90',
                layout: [
                    {
                        component: iro.ui.Box,
                        options: {
                          borderColor: '#ffffff'
                        }
                      },
                      {
                        component: iro.ui.Slider,
                        options: {
                          sliderType: 'hue',
                          borderColor: '#000000'
                        }
                      }
                ]
              });
              

            $scope.colorPicker.on('color:change', function(){
            $scope.updateModel();
                
                //$scope.$apply();
            })

            $scope.updateModel();
            $timeout(_ => {
                const firstInputElm = $element[0].querySelector('input')
                console.log('Setting focus to',firstInputElm);
                firstInputElm.focus();
            }, 500);

            $element[0].addEventListener('paste', function($event){
                let paste = ($event.clipboardData || window.clipboardData).getData('text');

                $scope.setColor(paste)
                $event.preventDefault();
                $event.stopPropagation();
            });

            
        });

        $scope.updateModel = function(){
            $timeout( _ =>{
                $scope.color.h = $scope.colorPicker.color.hsl.h
                $scope.color.s = $scope.colorPicker.color.hsl.s
                $scope.color.l = $scope.colorPicker.color.hsl.l
            })
        }

        $scope.updatePicker = function(){
            $scope.setColor($scope.color);
        }

        // $scope.colorLogs = JSON.parse(localStorage.getItem('id3Plugin/colorLog'));
        // if(id3IsNullOrEmpty($params)){
        //     $scope.color = $scope.arrToColor([0,0,0,255]);
        //     $scope.original = $scope.arrToColor([0,0,0,255]);
        // }
        // else{
        //     $scope.color = $scope.arrToColor($scope.hexToRgb($params));
        //     $scope.original = $scope.arrToColor($scope.hexToRgb($params));
        // }
        
        console.log('fwColorPickerCtrl/init', $params);
    }

    $scope.apply = function($color){

        $scope.color = $color;
    }

    $scope.setColor = function($color){
        $scope.colorPicker.color.set($color);
    }

    $scope.addColorLog = function($color){
        if(!Array.isArray($scope.colorLogs)) $scope.colorLogs = [];
        
        lColorIndex = $scope.colorLogs.findIndex($c => $scope.colorToStr($c) == $scope.colorToStr($color));
        console.log('addColorLog',lColorIndex)
        if(lColorIndex >= 0) $scope.colorLogs.splice(lColorIndex,1);

        $scope.colorLogs.unshift($color);
        
        if($scope.colorLogs.length > 9){
            $scope.colorLogs.pop();
        }

        localStorage.setItem('id3Plugin/colorLog',JSON.stringify($scope.colorLogs));
    }


    $scope.arrToColor = function($arr){
        return {
            red : $arr[0],
            green : $arr[1],
            blue : $arr[2],
            alpha : $arr[3]
        }
    }
    $scope.colorToArr = function($color){
        return Object.keys($color).map($k => $color[$k]);
    }
    $scope.colorToStr = function($color){
        return $scope.rgbToHex(...$scope.colorToArr($color));
    }

    $scope.rgbToHex = function(r, g, b, a=255) {
        const lRgb = (a==255) ? [r,g,b] : [r,g,b,a];

        return '#' + lRgb.map(x => {
            const hex = x.toString(16)
            return hex.length === 1 ? '0' + hex : hex
        }).join('')
    }
      
      
    $scope.hexToRgb = function(hex){
        if(hex.length == 7) hex += 'ff';

        return hex
                .replace(
                    /^#?([a-f\d])([a-f\d])([a-f\d])$/i
                    ,
                    (m, r, g, b) => '#' + r + r + g + g + b + b)
                        .substring(1)
                        .match(/.{2}/g)
                        .map(x => parseInt(x, 16)
                )
    }

});

// ************************
//#region COLOR PALETTE

id3Plugin
.controller('colorPaletteEditorDialogCtrl', function($scope, $rootScope, $filter, $element, $q, $timeout,$id3UI,$id3IO){
    $scope.colorList = Array.from(new Array(9)).map( (e,i) => i+1);
    
    $scope.dialogOptions.actions = [
        {label: 'Apply', action: function () {
            $scope.closeAndReturn($scope.model);
        }},
        {label: 'Cancel', action: function () {
            $scope.close();
        }}
    ];

    $scope.init = function($params){
        palettes = $params.color_palette;

        if(Array.isArray(palettes.primary)) palettes.primary = {};
        if(Array.isArray(palettes.secondary)) palettes.secondary = {};
        if(Array.isArray(palettes.action)) palettes.action = {};

        $scope.model = structuredClone(palettes);
        console.log('colorPaletteEditorDialogCtrl',palettes);
    }

    $scope.colorPaletteStyles = function(){
        const basePrimary = $filter('id3HslPart')($scope.model.primary,'hs');
        const baseSecondary = $filter('id3HslPart')($scope.model.secondary,'hs');
        const baseAction = $filter('id3HslPart')($scope.model.action,'hs');
        
        const primary = $filter('id3HslPart')($scope.model.primary);
        const secondary = $filter('id3HslPart')($scope.model.secondary);
        const action = $filter('id3HslPart')($scope.model.action);

        const result = [];
        //console.log('colorPaletteStyles',$scope.model.primary, primary, basePrimary);

        if(primary != '') {
            result.push(`--id3-color-primary: hsl(${primary})`);
            result.push(`--id3-color-primary-revert: hsl(${basePrimary}, ${$scope.model.primary.l >= 50 ? 0 : 100}%)`);
        }
        if(secondary != '') {
            result.push(`--id3-color-secondary: hsl(${secondary})`);
            result.push(`--id3-color-secondary-revert: hsl(${baseSecondary}, ${$scope.model.secondary.l >= 50 ? 0 : 100}%)`);
        };
        if(action != ''){
            result.push(`--id3-color-action: hsl(${action})`);
            result.push(`--id3-color-action-revert: hsl(${baseAction}, ${$scope.model.action.l >= 50 ? 0 : 100}%)`);
        }

        if(basePrimary != '') result.push(`--id3-color-base-primary: ${basePrimary}`);
        if(baseSecondary != '') result.push(`--id3-color-base-secondary: ${baseSecondary}`);
        if(baseAction != '') result.push(`--id3-color-base-action: ${baseAction}`);
        
        

        return result.join(';');
    }

    $scope.selectPreset = function(){
        $id3UI.dialog('color-preset-picker').then( $preset => {
            $scope.applyPreset($preset);
        })
    }
    $scope.applyPreset = function($data){
        const lMainKeys = ['primary','secondary','action'];
        const lHslKeys = ['h','s','l'];
        lMainKeys.forEach($k => {
            lHslKeys.forEach($c => {
                $scope.model[$k][$c] = $data[$k][$c];
            })
        })
    }

    $scope.copyVariationClass = function($className,$variation){
        $id3IO.toClipboard(`id3-color-${$className}-${$variation} id3-color-apply-bg`);
    }
    $scope.copyColorsToClipboard = function(){
        const data = JSON.stringify($scope.model);//.replace(/\"/g,'');
        $id3IO.toClipboard(data);
    }
});

id3Plugin
.controller('colorPresetPickerDialogCtrl', function($scope, $rootScope, $element, $q, $id3IO){
    $scope.presets = {
        groups:[]
    };
    $scope.dialogOptions.actions = [
        {label: 'Cancel', action: function () {
            $scope.close();
        }}
    ];

    $scope.init = function(){

        $id3IO.getData('color-presets.json').then($paletteList => {
            $scope.presets.groups = $paletteList; 
            //console.log('colorPresetPickerDialogCtrl/init', $paletteList);
        });

    }

    $scope.select = function($item){
        $scope.closeAndReturn($item);
    }

});

id3Plugin
.controller('fwIconPickerDialogCtrl', function($scope, $rootScope, $element, $q, $timeout){
    $scope.list = [];
    $scope.styles = [
        {label: 'Thin', weight: 'fat'},
        {label: 'Light', weight: 'fal'},
        {label: 'Regular', weight: 'far'},
        {label: 'Solid', weight: 'fas'},
        {label: 'Duotone', weight: 'fad'}
    ]
    $scope.context = {
        keywords : '',
        style: 'fal'
    }

    $scope.init = function($params){
        $scope.searchEngine = new FontAwesomeQL({apiKey: '6210D469-A548-4AED-ACA8-7DA9CB0E58D9'});

        $scope.context.keywords = $params.search;
        $scope.search();
    }

    $scope.search = function(){
        $timeout(_ => {
            const searchIcon = $scope.context.keywords == '' ? ['arrow','user','nav','angle','back'].random() : $scope.context.keywords;

            $scope.searchEngine.search(searchIcon,{max: 30}).then( $result => {
                console.log('search result', $result);
                if($result != null){
                    const list = $result.map( ({id,styles}) => {
                        const weight = (styles.includes('brands')) ? 'fab' : undefined;
                        return {weight: weight, name: 'fa-' + id}
                    });
                    $timeout(_ => {
                        $scope.list = list;
                    });
                }
            })
        },150);
    }

    $scope.select = function($item, $weight){
        const item = structuredClone($item);

        item.weight = item.weight!=undefined ? item.weight : $weight;
        $scope.closeAndReturn(item);
    }
})

//#endregion
// ************************

// ************************
//#region STYLES

id3Plugin
.controller('stylesEditorDialogCtrl', function($scope, $rootScope, $filter, $element, $q){
    $scope.model = null;

    $scope.hoverEffects = [
        {label: 'General', items: [
            {label:'None', value: 'none'},
            {label:'Collapse', value: 'collapse'},
            {label:'Grow', value: 'grow'},
            {label:'Invert', value: 'fade-in'},
            {label:'Expand text', value: 'text-expand'},
        ]},
        {label: 'Bubble', items: [
            {label:'Bubble:Top left', value: 'bubble-top-left'},
            {label:'Bubble:Top right', value: 'bubble-top-right'},
            {label:'Bubble:Center', value: 'bubble-center'},
            {label:'Bubble:Bottom right', value: 'bubble-bottom-right'},
            {label:'Bubble:Bottom left', value: 'bubble-bottom-left'},
        ]},
        {label: 'Pull', items: [
            {label:'Pull:Up', value: 'pull-up'},
            {label:'Pull:Right', value: 'pull-right'},
            {label:'Pull:Left', value: 'pull-left'},
        ]},
        {label: 'Slide', items: [
            {label:'Slide:Top', value: 'slide-top'},
            {label:'Slide:Right', value: 'slide-right'},
            {label:'Slide:Left', value: 'slide-left'},
            {label:'Slide:Bottom', value: 'slide-bottom'},
        ]},
        {label: 'Opening', items: [
            {label:'Opening:Horizontal', value: 'open-h'},
            {label:'Opening:Vertical', value: 'open-v'},
        ]},
        {label: 'Closing', items: [
            {label:'Closing:Horizontal', value: 'close-h'},
            {label:'Closing:Vertical', value: 'close-v'},
        ]}
    ]

    $scope.dialogOptions.actions = [
        {label: 'Apply', action: function () {
            $scope.closeAndReturn($scope.model);
        }},
        {label: 'Cancel', action: function () {
            $scope.close();
        }}
    ];

    $scope.init = function($params){
        $scope.palettes = $params.color_palette;

        $scope.model = structuredClone($params.style_vars);
    }


    $scope.colorPaletteStyles = function(){
        const basePrimary = $filter('id3HslPart')($scope.palettes.primary,'hs');
        const baseSecondary = $filter('id3HslPart')($scope.palettes.secondary,'hs');
        const baseAction = $filter('id3HslPart')($scope.palettes.action,'hs');
        
        const primary = $filter('id3HslPart')($scope.palettes.primary);
        const secondary = $filter('id3HslPart')($scope.palettes.secondary);
        const action = $filter('id3HslPart')($scope.palettes.action);

        const result = [];
        //console.log('colorPaletteStyles',$scope.palettes.primary, primary, basePrimary);

        if(primary != '') {
            result.push(`--id3-color-primary: hsl(${primary})`);
            result.push(`--id3-color-primary-revert: hsl(${basePrimary}, ${$scope.palettes.primary.l >= 50 ? 0 : 100}%)`);
        }
        if(secondary != '') {
            result.push(`--id3-color-secondary: hsl(${secondary})`);
            result.push(`--id3-color-secondary-revert: hsl(${baseSecondary}, ${$scope.palettes.secondary.l >= 50 ? 0 : 100}%)`);
        };
        if(action != ''){
            result.push(`--id3-color-action: hsl(${action})`);
            result.push(`--id3-color-action-revert: hsl(${baseAction}, ${$scope.palettes.action.l >= 50 ? 0 : 100}%)`);
        }

        if(basePrimary != '') result.push(`--id3-color-base-primary: ${basePrimary}`);
        if(baseSecondary != '') result.push(`--id3-color-base-secondary: ${baseSecondary}`);
        if(baseAction != '') result.push(`--id3-color-base-action: ${baseAction}`);
        
        result.push(`--id3-ui-corner:${$scope.model.corner.value}${$scope.model.corner.unit}`);
        result.push(`--id3-anim-duration:${$scope.model.anim_speed}s`);
        return result.join(';');
    }
})


//#endregion
// ************************

id3Plugin
.controller('fwPictureCropDialogCtrl', function($scope, $rootScope,$element, $q, $timeout,$id3UI, $id3IO){
    
   
    $scope.options = {};
    $scope.output = {
        width: 300,
        height:300
    };
    $scope.model = null;
    $scope.$cropper = null;

    $scope.dragOptions = {
        start: function (e) {
            //console.log("STARTING");
        },
        drag: function (e) {
            //console.log("DRAGGING");
        },
        stop: function (e) {
            // console.log("STOPPING @", e);
            $scope.model.y = e.target.offsetTop;
        },
        limit: {
            axis: 'Y'
        }
        //container: 'picture-drag-container'
    }

    $scope.dialogOptions.actions = [
        {label: 'Apply', action: function () {
            console.log('Apply', $scope.returnType);
            if($scope.returnType=='image'){
                $scope.returnImage();
            }
            else{
                $scope.returnModel();
            }
        }},
        {label: 'Cancel', action: function () {
            $scope.close();
        }}
    ];

    $scope.init = function($params){
        console.log('pictureEditDialogCtrl/init',$element);
        $scope.model = {
            file: null,
            picture: null,
            y: 0,
            width: 0
        };

        $scope.model.file = $params.file || $params;
        $scope.returnType = $params.returnAs || 'model';
        $scope.options = $params.options || {};

        $q.all([
            $id3IO.addScript('cropperjs','//cdnjs.cloudflare.com/ajax/libs/cropperjs/1.5.12/cropper.min.js'),
            $id3IO.addStyle('cropperjs','//cdnjs.cloudflare.com/ajax/libs/cropperjs/1.5.12/cropper.min.css')
        ]).then( _  => {
            $id3UI.waitFor('#canvas-picture', $element[0]).then( _ => {
            
                console.log('pictureCropDialogCtrl/init/waitFor', $element[0]);
    
                $scope.$elementImage = $element[0].querySelector('#canvas-picture');
                $scope.$elementPreviewImage = $element[0].querySelector('#preview-picture');
        
                if($scope.$cropper != null){
                    $scope.$cropper.destroy();
                    $scope.$cropper = null;
                }
                $scope.$elementImage.src = '';
        
                //$scope.model.file = params.pictureFile.getAsDataURL();
                $scope.loadFile();
            });
        })
        
    }

    $scope.addRequirement = function(){
        
    }

    $scope.loadFile = function () {
        if(typeof $scope.model.file == 'string'){
            $scope.$elementImage.src = $scope.model.file;
            $scope.applyEditorCapabilities();
            return;
        }

        const reader = new FileReader();
        console.log('loadFile', $scope.model.file)
        reader.onload = function (e) {
            // console.log('load image', e);
            // Render thumbnail
            

            //let lImg = document.createElement('img');
            $scope.$elementImage.onload = function () {
                // let lRatio = (300 / this.width);
                // $scope.model.width = this.width * lRatio;
                // $scope.dragOptions.limit.top = [0, (this.height*lRatio) - 300];
                // $scope.model.picture = e.target.result;
                
                $scope.applyEditorCapabilities();

                // document.body.removeChild(lImg);
            }
            //lImg.style.display = 'none';
            $scope.$elementImage.src = e.target.result;
            //document.body.appendChild(lImg);
        };

        // Read in the image file as a data URL.
        reader.readAsDataURL($scope.model.file);
    }

    $scope.returnModel = function(){
        $scope.$cropper.getCroppedCanvas(
            $scope.output // add to parameters
        ).toBlob($blob => {
            $scope.model.picture = $blob;

            console.log('returnModel',$scope.model);

            $scope.closeAndReturn($scope.model);
        },'image/png',1);

    }

    $scope.applyEditorCapabilities = function(){
        const lCropperOptions = Object.assign({
            //preview: $scope.$elementPreviewImage,
            dragMode: 'move'
        },$scope.options);

        $scope.$cropper = new Cropper($scope.$elementImage, lCropperOptions)

        $scope.$elementImage.addEventListener('crop', ($event) => {
            const lBoxData = $scope.$cropper.getCropBoxData();
            $timeout(_ => {
                $scope.output = lBoxData;
            });
        })
    }

    $scope.updateCropData = function(){
        $scope.$cropper.setCropBoxData($scope.output);
    }
    $scope.changeCropAspectRatio = function($aspectRatio){
        $scope.$cropper.setAspectRatio($aspectRatio);
    }

    $scope.zoom = function($factor){
        $scope.$cropper.zoom($factor);
    }

    $scope.rotate = function($degree){
        $scope.$cropper.rotate($degree);
    }

    $scope.scaleX = function($factor){
        const lData = $scope.$cropper.getData();
        $scope.$cropper.scaleX(lData.scaleX * $factor);
    }
    $scope.scaleY = function($factor){
        const lData = $scope.$cropper.getData();
        $scope.$cropper.scaleY(lData.scaleY * $factor);
    }


    $scope.returnImage = function(){
        $scope.$cropper.getCroppedCanvas({
            width: 300, 
            height:300
        }).toBlob( $blob => {
            console.log('returnImage',lResult);
            $scope.closeAndReturn({src: $blob});
        });
    }

});

id3Plugin
.controller('shortcodesCtrl', function($scope, $rootScope, $q, $timeout, $id3Rest, $id3IO){
    $scope.list = [];
    $scope.state = '';

    $scope.init = function(){
        $scope.fetchData();
    }

    $scope.fetchData = function(){
        $scope.state = 'fetching';
        return $id3Rest.call('framework/infos/shortcodes')
                .then($response=>{
                    const lGroups = (Array(...(new Set($response.map($sc => $sc.namespace)))))
                                        .map($g => {
                                            console.log('$g', $g);
                                            return {
                                                name : $g.replace('ID3\\',''),
                                                items: $response.filter($sc => $sc.namespace== $g)
                                            }
                                        });
                    
                    $scope.list = lGroups;

                    $scope.state = '';
                });
    }

    $scope.copyToClipboard = function($item){
        const lShortcode = [
            '[',
            $item.tag,
            ']'
        ];

        if($item.infos != null && $item.infos.args != undefined){
            const lArgs = $item.infos.args.map($arg => $arg.name + '="' + $arg.type + '"');
            lShortcode.splice(2,0,' ' + lArgs.join(' '));
        }

        
        $id3IO.toClipboard(lShortcode.join(''));
    }
});


id3Plugin
.controller('restsDialogCtrl', function($scope, $rootScope, $q, $timeout, $id3Rest, $id3IO){
    $scope.list = [];
    $scope.state = '';

    $scope.init = function(){
        $scope.fetchData();
    }

    $scope.fetchData = function(){
        $scope.state = 'fetching';
        return $id3Rest.call('framework/infos/rests')
                .then($response=>{
                    $scope.list = Object.keys($response)
                                    .map($k => {
                                        const lPath = $k.trimChar('/');

                                        const lItem = Object.assign({
                                            path: lPath,    
                                        }, $response[$k]);

                                        if(!Array.isArray(lItem.methods)) lItem.methods = lItem.methods.split(', ');

                                        return lItem;

                                    });
                    

                    $scope.state = '';
                });
    }

    $scope.copyToClipboard = function($item){
        $id3IO.toClipboard('/wp-json/id3-rest/' + $item.path);
    }
});

id3Plugin
.controller('fwHelpDialogCtrl', function($scope, $rootScope, $q, $timeout, $id3IO){
    $scope.$locales = $locales;
    
    $scope.model = {
        path: ''
    }

    $scope.init = function($params){
        $scope.model.path = $id3IO.absPath('views/statics/helps/' + $params + '.html?v=' + (new Date()).getTime());
    }
})