id3Plugin
.directive('ls', ['$parse', function ls($parse){
    return {
        restrict: 'E,A',
        compile: function compile(tElement, tAttrs, transclude) {
            return {
               pre: function preLink(scope, iElement, iAttrs, controller) {
                    let lTranslatedContent = iElement.html().translate();
                    let lFormatParams = iAttrs.params;
                    if(lFormatParams == null && iAttrs.lstr != '') lFormatParams = iAttrs.lstr;
                    
                    if(lFormatParams != null){
                        lFnFormatParams = $parse(lFormatParams);
                        lFormatParams = lFnFormatParams(scope);
                        if(!Array.isArray(lFormatParams)) lFormatParams = [lFormatParams];
                        
                        lTranslatedContent = lTranslatedContent.format.apply(lTranslatedContent, lFormatParams);
                    }
                    iElement.html('<span>' + lTranslatedContent + '</span>');
               }
            }
        }
    }
}]);

id3Plugin
.directive('id3Svg', ['$id3IO', function id3Svg($id3IO){
  return {
    restrict: 'E',
    scope: {
      src : '@id3Src'
    },
    template: '<ng-include src="absPath"></ng-include>',
    link: function($scope, $element, $attr){
      const lSrc = $id3IO.absPath($scope.src, '{0}.svg');
      console.log('id3Svg@link', lSrc);

      $scope.absPath = lSrc;
    }
  }
}])

id3Plugin
.directive('id3WpMedia', ['$parse', function siWpMedia($parse){
  return {
    restrict: 'E',
    templateUrl: siAdminDirectiveTemplatePath('si-wp-media'),
    replace: true,
    scope: {
      model: '=siModel',
      type: '@?',
      caption: '@?',
      placeholder: '@?',
      onChange: '&?siChange'
    },
    link: function($scope, $elm, $attr){
      if($scope.type == undefined) $scope.type = 'image';
      $scope.init($elm[0]);
    },
    controller: function($scope, $rootScope,$timeout,$q, $siUI, $siUtils){
      $scope._wpDialog = null;

      $scope.init = function(){

      }

      $scope.selectMedia = function(){
        $scope.openMedia();
      }

      $scope.openMedia = function(){
        const lDialog = $scope.getDialog();
        lDialog.open();
      }

      $scope.getDialog = function(){
        if($scope._wpDialog != null) return $scope._wpDialog;

        const wpDialog = wp.media({
                  title: 'Select Media',
                  multiple : false,
                  library : {
                      type : $scope.type,
                  }
              });
        wpDialog.on('close', function(){
            const lSelection =  wpDialog.state().get('selection');
            const lMedia = [];
            lSelection.each(function($item) {
                console.log('attachement', $item);
                const lAttr = $item.attributes;
                lMedia.push(lAttr);
            });
            
            if(lMedia.length > 0){
              

              $timeout(function(){
                $scope.model = lMedia[0];
                $scope.triggerChange();
              });
            }
        });

        //wpDialog.on('open',function() {
          // On open, get the id from the hidden input
          // and select the appropiate images in the media manager
          // var selection =  wpDialog.state().get('selection');
          // var ids = jQuery('input#myprefix_image_id').val().split(',');

          // ids.forEach(function(id) {
          //   var attachment = wp.media.attachment(id);
          //   attachment.fetch();
          //   selection.add( attachment ? [ attachment ] : [] );
          // });

        //});

        $scope._wpDialog = wpDialog;
        return wpDialog;
      }

      $scope.clearMedia =function(){
        $scope.model = null;
        $scope.triggerChange();
      }

      $scope.triggerChange = function(){
        if(typeof($scope.onChange) == 'function'){
          $scope.onChange({$media: $scope.model});
        }

      }
    }
  }
}]);

id3Plugin
.directive('id3ListInputContainer', function id3ListInputContainer(){
    return {
        restrict: 'E',
        transclude: true,
        template: '<ng-transclude></ng-transclude>',
        link: function($scope, $element, $attr){

        }
    }
});

id3Plugin
.directive('id3Transclude', function id3Transclude(){
  return {
    link: function( $scope, $element, $attrs, controller, $transclude ) {
        if ( !$transclude ) {
            throw minErr( 'ngTransclude' )( 'orphan',
                'Illegal use of ngTransclude directive in the template! ' +
                'No parent directive that requires a transclusion found. ' +
                'Element: {0}',
                startingTag( $element ));
        }
        var innerScope = $scope.$new();

        $transclude( innerScope, function( clone ) {
            $element.empty();
            $element.append( clone );

            $element.on( '$destroy', function() {
                innerScope.$destroy();
            });
        });
    }
};
});

//#region  Event scoping

id3Plugin
.directive('id3KeyScope', function id3KeyScope(){
  return {
    restrict: 'A',
    link: function($scope, $element, $attr){
      $element[0].addEventListener('keydown', function($event){
        $event.stopPropagation();
      });
    }
  }
});

id3Plugin
.directive('id3ClickScope', function id3ClickScope(){
  return {
    restrict: 'A',
    link: function($scope, $element, $attr){
      $element[0].addEventListener('click', function($event){
        $event.stopPropagation();
        return false;
      })
    }
  }
});

id3Plugin
.directive('id3EventScope', function id3EventScope(){
  return {
    restrict : 'A',
    link: function($scope,$element, $attr){
      const lEvents = $attr.id3EventScope.split(',');
      if(lEvents.length === 0) return;

      lEvents.forEach($ev => {
        $element[0].addEventListener($ev, function($event){
          $event.stopPropagation();
        })
      })
      
    }
  }
})

//#endregion

id3Plugin
.directive('id3Shortcode',[function id3Shortcode(){
  return {
    restrict: 'E',
    replace: true,
    //template:'<span class="id3-shortcode" ng-click="copyShortcodeToClipboard()">[{{shortcode}}] <i class="fal fa-copy"></i></span>',
    compile: function compile(tElement, tAttrs, transclude) {
        return {
            pre: function preLink($scope, iElement, iAttrs, controller) {
                $scope.shortcode = iElement.html();
                // let lTranslatedContent = iElement.html().translate();
                // let lFormatParams = iAttrs.params;
                // if(lFormatParams == null && iAttrs.lstr != '') lFormatParams = iAttrs.lstr;
                
                // if(lFormatParams != null){
                //     lFnFormatParams = $parse(lFormatParams);
                //     lFormatParams = lFnFormatParams(scope);
                //     if(!Array.isArray(lFormatParams)) lFormatParams = [lFormatParams];
                    
                //     lTranslatedContent = lTranslatedContent.format.apply(lTranslatedContent, lFormatParams);
                // }
                iElement.on('click', $scope.copyShortcodeToClipboard);
                iElement.addClass('id3-shortcode');
                iElement.html('<i class="fal fa-code"></i> <span>' + 'Click to copy'.translate() + ' [' + $scope.shortcode + ']</span>');
            }
        }
    },
    controller: function($scope, $element,$id3IO, $id3UI){
      //$scope.shortcode = $element[0].innerText;

      $scope.copyShortcodeToClipboard = function(){

        $id3IO.toClipboard('[' + $scope.shortcode + ']');

      }
    }
  }
}])



//#region UI Helpers

// Icons
id3Plugin
.directive('icon', function icon(){
  return {
    restrict: 'E',
    
    compile: function compile(tElement, tAttrs, transclude) {
      return {
         pre: function preLink(scope, iElement, iAttrs, controller) {
            const icon = {
              name: iElement.text(),
              size: iAttrs.size,
              mode: iAttrs.mode == undefined ? 'fal' : 'fa' + iAttrs.mode[0]
            };

            

            const lStyle = icon.size != undefined ? 'font-size:' + icon.size + 'rem' : '';
            iElement[0].outerHTML =`<i class="${icon.mode} fa-${icon.name}" style="${lStyle}"></i>`;

         }
      }
    },
  }
})

// Dialogs
id3Plugin
.directive('id3DialogActions', function id3DialogActions(){
  return {
    restrict: 'E',
    template: [
      '<md-button class="{{button.primary ? \'md-primary md-raised\' : \'\'}}" ng-repeat="button in dialogOptions.actions" ng-click="button.action()">{{button.label.translate()}}</md-button>'
    ]
  }
});

id3Plugin
.directive('id3DialogToolbar', function id3DialogToolbar(){
  return {
    restrict: 'E',
    template: [
      '<md-toolbar>',
        '<div class="md-toolbar-tools">',
        '<h2>{{title | translate}}</h2>',
        '<span flex></span>',
        '<md-button class="md-icon-button" ng-click="close()"><i class="fal fa-times"></i></md-button>',
        '</div>',
      '</md-toolbar>'
    ].join(''),
    replace:true,
    link: function($scope, $element, $attr){
      $scope.title = $attr.title;
    }
  }
});


// Panels
id3Plugin
.directive('id3PanelToolbar',function id3PanelToolbar(){
  return {
    restrict: 'E',
    template: [
      '<md-toolbar>',
        '<md-button class="md-icon-button" ng-click="close()"><i class="fal fa-lg fa-arrow-left"></i></md-button>',
        '<h1>{{title.translate()}}</h1>',
      '</md-toolbar>'
    ].join(''),
    replace:true,
    link: function($scope, $element, $attr){
      $scope.title = $attr.title;
    }
  }
});

// Layout
id3Plugin
.directive('layoutGap', function layoutGap(){
  return {
    restrict: 'A',
    link: function($scope, $element, $attrs){
      const lGap = $attrs.layoutGap ? $attrs.layoutGap : 1;
      $element.addClass('layout-gap-' + lGap);
      
    }
  }
})

// Page
id3Plugin
.directive('id3PagePluginActions', function id3PagePluginActions(){
  return{
    restrict: 'E',
    replace: true,
    transclude: true,
    template: `
    <div class="id3-page-plugin-actions">
      <div class="id3-actions-container" ng-transclude></div>
    </div>
    `
  }
})

//#endregion

id3Plugin
.directive('id3Accordeon', function id3Accordeon(){
  return {
    restrict: 'E',
    replace: true,
    transclude: true,
    template: `
      <div class="id3-accordeon">
        <div class="id3-accordeon-section-container" ng-transclude></div>
      </div>
    `,
    link: function($scope, $element, $attr){
      $scope.init();
    },
    controller: function($scope, $rootScope, $element, $timeout, $q){
      $scope.init = function(){
        const lSections = $element[0].querySelectorAll('.id3-accordeon-section');
        if(lSections.length > 0){
          lSections[0].classList.add('id3-open');
        }
      }


      $scope.closeAll = this.closeAll = function(){
        const lDefer = $q.defer();

        const lAllSection = Array.from($element[0].querySelectorAll('.id3-accordeon-section'));
        const lAllOpen = lAllSection.filter($elm => $elm.classList.contains('id3-open'));
        lAllOpen.forEach(($elm,$index) => {
            if($index == 0){
              $elm.querySelector('.id3-accordeon-section-body').addEventListener('transitionend',function(){
                lDefer.resolve();
              });
            }
            $elm.classList.remove('id3-open');
        });

        lAllSection.filter($elm => $elm.classList.contains('id3-closing')).forEach($elm => {
          $elm.classList.remove('id3-closing');
        })

        if(lAllOpen.length == 0){
          return $q.resolve();
        }

        return lDefer.promise;
      }

    }
  }
});

id3Plugin
.directive('id3AccordeonSection', function id3AccordeonSection(){
  return {
    restrict: 'E',
    require: '^id3Accordeon',
    replace: true,
    transclude: {
      title : 'id3SectionTitle',
      body: 'id3SectionBody'
    },
    scope:true,
    template:`
      <div class="id3-accordeon-section">
        <div class="id3-accordeon-section-title" ng-click="open()">
          <h3 ng-transclude="title"></h3>
          <i class="fal fa-angle-down"></i>
        </div>
        <div class="id3-accordeon-section-body">
          <div class="id3-section-body-content" ng-transclude="body"></div>
        </div>
      </div>
    `,
    link: function($scope, $element, $attrs, $parentController){
      $scope.accordeonCtrl = $parentController;
    },
    controller: function($scope, $element){
      

      $scope.open = function(){
        
        const lPrev = $element[0].previousElementSibling;
            

        if($element[0].classList.contains('id3-open')){
          $element[0].classList.remove('id3-open');
          if(lPrev != null) lPrev.classList.remove('id3-closing');
        }
        else{
          
          $scope.accordeonCtrl.closeAll().then( _ => {
            $element[0].classList.add('id3-open');

              if(lPrev != null) lPrev.classList.add('id3-closing');
            
          })
          
        }
      }
    }

  }
});



id3Plugin
.directive('id3ListInput', function id3ListInput($parse){
    return {
        restrict: 'E',
        replace: true,
        transclude: true,
        require: '^ngModel',
        scope: {
            editor: '@id3Editor',
            editorOptions: '=?id3EditorOptions',
            max: '@id3Max',
            addLabel: '@id3AddLabel',
            newItemFormat: '&?id3NewItemFormat',
            ngModel: '='
        },
        template: ''.concat(
            '<div class="id3-list-input">',
                '<div class="id3-list-container"  ui-sortable="sortOptions" ng-model="ngModel">',
                    '<div class="id3-list-item" ng-repeat="$item in ngModel" ng-click="editItem($item, $index)">',
                      '<div id3-transclude></div>',
                      '<div class="id3-list-item-actions">',
                        '<md-button ng-click="removeItem($index)" class="md-icon-button"><i class="fal fa-times"></i></md-button>',
                      '</div>',
                    '</div>',
                '</div>',
                '<div class="id3-list-input-actions">',
                  '<md-button ng-if="editor!=null && ngModel.length < max" ng-click="addItem()"><i class="fal fa-plus"></i> {{addLabel | translate}}</md-button>',
                  '<md-button class="md-warn" ng-if="ngModel.length > 0" ng-click="clearList()"><i class="fal fa-trash"></i> <ls>Clear</ls></md-button>',
                '</div>',
            '</div>'
        ),
        
        link: function($scope, $element, $attr){
            $scope.sortOptions = {axis: 'Y', scroll: false, active: $attr.id3Sortable != undefined};
            $scope.max = ($scope.max == undefined) ? 99 : $scope.max;
            $scope.addLabel = ($scope.addLabel == undefined) ? 'Add' : $scope.addLabel;
            $scope.editor = ($scope.editor == undefined) ? null : $scope.editor;
            $scope.newItemFormat = ($scope.newItemFormat == undefined) ? function($item){return $item} : $scope.newItemFormat;
            $scope.editorOptions = ($scope.editorOptions == undefined) ? {} : $scope.editorOptions;
        },
        controller: function($scope, $rootScope, $timeout,$id3UI){
            if($scope.editor == null) return;
            
            if(id3IsNullOrUndefined($scope.ngModel)) $scope.ngModel = [];
            
            $scope.addItem = function(){
              //console.log('id3ListInput', $scope.editorOptions);
              const lEditorParams = Object.assign($scope.newItemFormat({}), $scope.editorOptions.params);
              
              $id3UI.dialog($scope.editor,lEditorParams).then($result => {
                $scope.ngModel.push($result);
              },_=>{});
            }

            $scope.editItem = function($item, $index){
              const lEditorParams = Object.assign(angular.copy($item), $scope.editorOptions.params);
              $id3UI.dialog($scope.editor,lEditorParams).then($result => {
                $scope.ngModel.splice($index,1, $result);
              },_=>{});
            }

            $scope.removeItem = function($index){
              $scope.ngModel.splice($index,1);
            }

            $scope.clearList = function(){
              $scope.ngModel.splice(0,$scope.ngModel.length);
            }
        }
    }
});

id3Plugin
.directive('id3ColorPicker', ['$compile', function id3ColorPicker($compile){
  return {
    restrict: 'A',
    require: 'ngModel',
    scope: {
      ngModel: '='
    },
    link: function($scope, $element, $attrs, ngModel){
      
      const lPickerPreview = $compile('<div class="id3-color-picker-preview" ng-click="openColorPicker()" style="--current-color:{{ngModel}}"></div>')($scope);
      const lParent = $element.parent();
      lParent.append(lPickerPreview);
      lParent.addClass('id3-color-picker-container');
    },
    controller: function($scope, $rootScope, $element, $q, $timeout, $id3UI){
        $scope.openColorPicker = function(){
          console.log('id3ColorPicker/openColorPicker')
          $id3UI.dialog('~/fw-color-picker',angular.copy($scope.ngModel)).then($result => {
            $scope.ngModel = $result;
          });
        }

        
    }
  }
}]);

id3Plugin
.directive('id3HslInput', [function id3HslInput(){
  return {
    restrict: 'E',
    require: '^ngModel',
    scope: {
      model: '=ngModel',
      // parts: '@?' CHECK BY ATTRIBUTE
    },
    link: function($scope, $element, $attr){
      $scope.inputs = $attr.parts ? $attr.parts.toLowerCase().split('') : ['h','s','l'];
      $scope.init();
    },
    template: `
      <div class="id3-hsl-input">
        <div class="id3-hsl-input-preview" style="--id3-hls-input-preview: {{getHslValue()}}" ng-click="openColorPicker()"></div>
        <div class="id3-hsl-input-part id3-part-h" ng-if="inputs.includes('h')">
          <input ng-model="model.h" ng-change="validate()">
          <label ls>Hue</label>
        </div>
        <div class="id3-hsl-input-part id3-part-s" ng-if="inputs.includes('s')">
          <input ng-model="model.s" ng-change="validate()">
          <label ls>Sat.</label>
          <span>%</span>
        </div>
        <div class="id3-hsl-input-part id3-part-l" ng-if="inputs.includes('l')">
          <input ng-model="model.l" ng-change="validate()">
          <label ls>Light.</label>
          <span>%</span>
        </div>
        
      </div>
    `,
    controller: function($scope,$id3UI){

      $scope.init = function(){
        if($scope.model.hue != undefined){
          $scope.model.h = $scope.model.hue;
          $scope.model.s = $scope.model.saturation;
          $scope.model.l = $scope.model.lightness;

          delete $scope.model.hue;
          delete $scope.model.saturation;
          delete $scope.model.lightness;
        }

      }
      $scope.validate = function(){
        ['h','s','l'].forEach($k => {
          if($scope.model[$k] == undefined && $scope.inputs.includes($k[0])){
            $scope.model[$k] = 10;
          }
        })
      }

      $scope.getHslValue = function(){
        const result = [];

        result.push(  $scope.model.h || 0);
        result.push( ($scope.model.s!=undefined ? $scope.model.s : 0) + '%');
        result.push( ($scope.model.l!=undefined ? $scope.model.l : 100) + '%');
        
        return 'hsl(' + result.join(',') + ')';
      }

      $scope.openColorPicker = function(){
        $id3UI.dialog('~/fw-color-picker',{color: $scope.model}).then($result => {
          console.log($result);
          $scope.model.h = $result.h;
          $scope.model.s = $result.s;
          $scope.model.l = $result.l;

          
          delete $scope.model.hue;
          delete $scope.model.saturation;
          delete $scope.model.lightness;
        });
      }
    }
  }
}])

id3Plugin
.directive('id3ColorPreview', [
function id3ColorPreview(){
  return {
    restrict: 'E',
    scope: {
      fgColor: '=fgColor',
      bgColor: '=bgColor',
      icon: '@icon'
    },
    replace:true,
    template: [
      '<div class="id3-color-preview" style="--fg-color:{{fgColor}};--bg-color:{{bgColor}}"><i class="fal fa-{{icon}}"></i></div>'
    ].join(''),
    link: function($scope, $element, $attrs){
      $scope.icon = ($scope.icon == undefined) ? 'text' : $scope.icon;
    }
  }
}]);

id3Plugin
.directive('id3IconInput', function id3IconInput(){
  return {
    restrict: 'E',
    required: '^ngModel',
    scope: {
      ngModel: '=',
      
    },
    template: `<div class="id3-icon-input">
      <i class="{{ngModel}}" ng-click="selectIcon()"></i>
      <input ng-model="ngModel" />
    </div>`, 
    controller: function($scope,$element,$q,$id3UI){
      $scope.selectIcon = function(){
        const rx = /fa-(.*)/g;
        const arr = rx.exec( $scope.ngModel);
        const iconName = arr && arr.length > 0 ? arr[1] : 'arrow';

        $id3UI.dialog('~/fw-icon-picker',{search : iconName}).then(result => {
          $scope.ngModel = `${result.weight} ${result.name}`;
        });
      }
    }
  }
})

id3Plugin
.directive('id3Help', function id3Help(){
  return {
    restrict:'E',
    transclude:true,
    scope: {
      src: '@'
    },
    template: [
      '<span class="id3-help" ng-click="showHelp()"><ng-transclude><span></span></ng-transclude><i class="fal fa-question-circle"></i></span>'
    ].join(''),
    replace: true,
    controller: function($scope, $rootScope, $id3IO, $id3UI){
      $scope.showHelp = function(){
        $id3UI.dialog('~/fw-help', $scope.src);
      }
    }
  }
});

id3Plugin
.directive('id3PagePicker', ['$compile', function id3PagePicker($compile){
  return {
    restrict: 'E',
    require: '^ngModel',
    scope: {
      model: '=ngModel',
      placeholder: '@?'
    },
    replace: true,
    template: [
      '<div class="id3-page-picker">',
        '<md-button class="md-icon-button" ng-if="selectedPage!=null" ng-click="clearPage()"><i class="fal fa-times"></i></md-button>',
        '<md-select ng-model="selectedPage" placeholder="{{placeholder}}"',
                    ' md-on-open="loadPages()"',
                    ' md-on-close="clearSearchTerm()"',
                    ' ng-change="updateModel()"',
                   '>',
          '<md-select-header>',
            '<input ng-model="searchTerm" ',
                   'type="search" placeholder="Ex. Listings"',
                   'class="md-select-header-searchbox md-text">',
          '</md-select-header>',
          
          '<md-option value="{{page.id}}" ng-repeat="page in pages | filter:searchTerm">',
            '{{page.title}}',
          '</md-option>',
        '</md-select>',
       
      '</div>'
    ].join(''),
    link: function($scope, $element, $attrs, ngModel){
        $scope.$modelCtrl = ngModel;
        $scope.placeholder = $scope.placeholder || 'Select a page'.translate()
        $scope.init();

        $element.find('input').on('keydown', function (ev) {
          ev.stopPropagation();
        });
    },
    controller: function($scope, $rootScope, $element, $q, $timeout, $id3UI, $id3Rest){
        $scope.selectedPage = null;
        $scope.searchTerm = '';

        $scope.init = function(){

          $scope.loadPages()
          .then(_ => {
            $timeout(_ => {
              $scope.selectedPage = $scope.model;
              console.log('id3PagePicker/init', $scope.selectedPage)
            })
          });
        }

        $scope.updateModel = function(){
          $scope.$modelCtrl.$setViewValue($scope.selectedPage);
        }
        
        $scope.loadPages = function(){
          return $id3Rest.get('pages').then($pages => {
            $scope.pages = $pages.map($p => {
              return {
                id: $p.ID,
                title: $p.post_title
              }
            });
          });
        }
        $scope.clearPage = function(){
          $scope.selectedPage = null;
          $scope.$modelCtrl.$setViewValue(null);
        }

        $scope.clearSearchTerm = function(){
          $scope.searchTerm = '';
        }
        
    }
  }
}]);


id3Plugin
.directive('id3InputList', [function id3InputList(){
  return {
    restrict: 'E',
    transclude: true,
    replace: true,
    template: `
      <div class="id3-input-list" ng-transclude></div>
    `
  }
}]);

id3Plugin
.directive('id3ListSubheader',[function id3ListSubheader(){
  return {
    restrict: 'E',
    transclude: true,
    replace: true,
    template: `
      <div class="id3-list-subheader" ng-transclude></div>
    `
  }
}])

id3Plugin
.directive('id3InputItem', [function id3InputItem(){
  return {
    restrict: 'E',
    transclude: true,
    replace: true,
    template: `
      <div class="id3-input-item" ng-transclude></div>
    `,

  }
}]);

id3Plugin
.directive('id3LocalizedInput', [function id3LocalizedInput(){
  return {
    restrict: 'E',
    require: '^ngModel',
    scope: {
      model: '=ngModel',
      locales: '=id3Locales'
    },
    replace: true,
    template: `
      <div class="id3-localized-input" ng-transclude>
        <input ng-model="model[currentLocale]" />
        <div class="locales">
          <span ng-repeat="ln in locales">{{ln}}</span>
        </div>
      </div>
    `,
    link: function($scope, $elm, $attrs, $modelCtrl){
      $scope.currentLocale = $scope.locales[0];
      if(!$scope.model){
        $scope.model = $scope.locales.reduce(($result,$cur) => {
          $result[$cur] = '';
          return $result;
        }, {});
      }
    }
  }
}]);


id3Plugin
.directive('id3PictureInput', [function id3PictureInput(){
  return {
    restrict: 'E',
    replace: true,
    require: '^ngModel',
    scope: {
      model: '=ngModel',
      maxWidth: '@',
      maxHeight: '@'
    },
    template: `
      <div class="id3-picture-input {{hasPicture() ? 'id3-has-picture' : ''}}">
        <div  ng-if="hasPicture()" class="id3-picture-info">
            <em>{{modelPreview.size | id3FileSize}}</em>
            <div>{{modelPreview.dimension.width}}px <i class="fal fa-times"></i> {{modelPreview.dimension.height}}px</div>
        </div>

        <div class="id3-picture-preview" ng-click="selectPicture()">
          <div ng-if="!hasPicture()" class="id3-picture-empty">
            <label ><ls>Select a picture</ls></label>
            <div>max. {{maxWidth}}x{{maxHeight}} px</div>
          </div>
          <img  ng-if="hasPicture()" ng-src="{{modelPreview.image}}" >
        </div>
        
        <div class="id3-picture-actions">
          <md-button class="id3-crop-button md-icon-button" ng-click="cropPicture()" ><i class="fal fa-crop"></i></md-button>
          <md-button class="id3-clear-button md-icon-button" ng-click="clearPicture()" ><i class="fal fa-times"></i></md-button>
        </div>
      </div>
    `,
    link: function($scope, $element, $attrs, $modelCtrl){

      $scope.$modelCtrl = $modelCtrl;

      $scope.init();

    },
    controller: function($scope,$element,$q,$timeout,$id3IO,$id3UI){
      $scope._hasPicture = false;
      $scope.modelPreview = {
        image: null,
        dimension: {
          width:0,
          height:0
        },
        size:0
      }
      
      $scope.init = function(){

      }

      $scope.hasPicture = function(){
        return $scope.modelPreview.image != null;
      }

      $scope.selectPicture = function(){
        $id3IO.fileSelect('image/*').then(
          async $result => {
            console.log('selectPicture/result', $result);
            const lImgSize = await $id3IO.fileGetImageSize($result);
            // update model
            const lFileUrl = await $id3IO.fileGetUrlContent($result);
            const lFileBin = await $id3IO.fileGetArrayBuffer($result);
            const lFileB64 = btoa(String.fromCharCode(...new Uint8Array(lFileBin)));
            $scope.modelPreview.blob = $result;

            if(lImgSize.width > $scope.maxWidth || lImgSize.height > $scope.maxHeight){
              // show crop tool
              //const lFileBin = await $id3IO.fileGetArrayBuffer($result);
              $scope.cropPicture($result);
              //console.log('selectPicture/result: size is too big, show crop tool');

            }
            else{
              
              $timeout(_ => {
                $scope.modelPreview.bin = lFileBin;
                $scope.modelPreview.image = lFileUrl;
                $scope.modelPreview.dimension = lImgSize;
                $scope.modelPreview.size = $result.size;
                

                $scope.$modelCtrl.$setViewValue(lFileB64);
              })
              
              console.log('selectPicture/result: Image is good', lFileUrl);
            }
          },
          _ => {
            console.log('selectPicture/cancel');
          }
        )
      }

      $scope.cropPicture = function($file=null){
        let lStartImage = $scope.modelPreview.blob
        if($file!=null){
          lStartImage = $file;
        }

        // Open crop tool dialog
        $id3UI.dialog('~/fw-picture-crop',{file: lStartImage},{zIndex: 250}).then(async $result => {
          console.log('cropResult', $result);
          const lFileUrl = await $id3IO.fileGetUrlContent($result.picture);
          const lImgSize = await $id3IO.fileGetImageSize($result.picture);
          const lFileBin = await $id3IO.fileGetArrayBuffer($result.picture);
          const lFileB64 = btoa(String.fromCharCode(...new Uint8Array(lFileBin)));

          //$scope.modelPreview.image = $result;
          $timeout(_ => {
            $scope.modelPreview.bin = lFileBin;
            $scope.modelPreview.image = lFileUrl;
            $scope.modelPreview.dimension = lImgSize;
            $scope.modelPreview.size = $result.picture.size;
            //$scope.modelPreview.blob = $result.picture;

            $scope.$modelCtrl.$setViewValue(lFileB64);
          });
        })

      }

      $scope.clearPicture = function(){
        $scope.modelPreview.image = null;
        $scope.modelPreview.dimension.width = 0;
        $scope.modelPreview.dimension.height = 0;
        $scope.modelPreview.size = 0;

        $scope.$modelCtrl.$setViewValue(null);
      } 
      
    }
  }
}]);


id3Plugin
.directive('id3Searchbox', function id3Searchbox(){
  return {
    restrict: 'E',
    required: '^ngModel',
    replace:true,
    scope:{
      model: '=ngModel',
      placeholder: '@?',
      ngModelOptions: '=?',
      ngChange:'&?'
    },
    template: `
    <div class="id3-searchbox {{model != '' ? 'has-value' : ''}} {{has_focus ? 'has-focus' : ''}}">
      <input type="text" ng-model="model" ng-model-options="ngModelOptions" ng-change="ngChange()" ng-focus="has_focus=true" ng-blur="has_focus=false" placeholder="{{placeholder.translate()}}" />
      <i class="fal fa-search"></i>
      <i class="fal fa-times" ng-click="clear()"></i>
    </div>
    `,
    
    controller: function($scope,$element){
    
      $scope.clear = function(){
        $scope.model = '';
        if($scope.ngChange != undefined) $scope.ngChange();
      }
    }
  }
})

