id3Plugin
.controller('progressPanelCtrl', function($scope,$rootScope, $timeout, $q){

    $scope.steps = [
        {label:'Initializing'}
    ];
    $scope.currentStepIndex = 0;
    $scope.currentStepPct = 0;

    $scope.init = function($params){
        console.log('progressPanelCtrl/init',$params);

        $scope.steps = $params.steps;
        $scope.options = Object.assign({mode:'parallel', onFail: _ => {}},$params.options);
        
        if(typeof $scope[$scope.options.mode] == 'function'){
            $scope[$scope.options.mode]()
                .then(
                    $result => {
                        $scope.closeAndReturn($result);
                    },
                    $error => {
                        $scope.close();
                        $scope.options.onFail($error);
                    }
                )
                .catch($error => {
                    $scope.options.onFail($error);
                });
        }
    }

    $scope.chain = function(){
        const lMax = $scope.steps.length + 1;
        const lDeferred = $q.defer();

        $scope.steps.reduce(
            ($result, $step, $index, $steps) => {
                return $result.then( 
                    $last => {
                        $scope.currentStepIndex = $index;
                        $scope.currentStepPct = Math.round((($index+1) / lMax) * 100)
                        return $step.action($last);
                    },
                    $fail => {
                        //lDeferred.reject($fail);
                        $steps.splice($index-1)
                        return $q.reject($fail);
                    }
                )
            }
        , $q.resolve())
        .then(
            $finalResult => {
                $scope.currentStepPct = 100;
                console.log('progressPanelCtrl/chain@success', $finalResult);
                $timeout(_ => {
                    lDeferred.resolve($finalResult);
                }, 250);
            },
            $fail => {
                console.log('progressPanelCtrl/chain@fail', $fail);
                lDeferred.reject($fail);
            }
        )
        .catch( $error => {
            console.log('progressPanelCtrl/chai@catch', $fail);
            lDeferred.reject($error);
        });

        return lDeferred.promise;
    }

    $scope.parallel = function(){
        const lDeferred = $q.defer();

        $scope.steps.forEach($step => {
            $step.action().then( $result => {
                $step._completed = true;
                if($scope.updateStatus() == true){
                    lDeferred.resolve($result);
                }
            })
        })
        
        return lDeferred.promise;
    }

    $scope.updateStatus = function(){
        const lMax = $scope.steps.length + 1;
        const lCount = $scope.steps.filter($s => $s._completed === true).length;
        $scope.currentStepIndex = lCount;
        $scope.currentStepPct = Math.round((lCount / lMax) * 100);

        return lCount == lMax;
    }
} )