const id3IsNullOrEmpty = function($value){
    
    if($value === null) return true;
    if($value === undefined) return true;
    //if(!isNaN($value) return false;

    
    if(Array.isArray($value) && $value.length == 0) return true;
    if(typeof $value === 'object' && Object.keys($value).length == 0) return true;
    if($value.toString().trim() === '') return true;

    return false;
}

const id3IsNullOrUndefined = function($value){
    if($value === null) return true;
    if($value === undefined) return true;
    
    return false;
}


if(typeof Array.prototype.first === 'undefined'){
    Array.prototype.first = function($default=''){
        if(this.length == 0) return $default;
        return this[0];
    }
}
if(typeof Array.prototype.last === 'undefined'){
    Array.prototype.last = function($default=''){
        if(this.length == 0) return $default;
        return this[this.length-1];
    }
}

if(typeof String.prototype.format === 'undefined'){
    
    String.prototype.format = function(){
        let lResult = this.toString();
        for (var i = 0; i < arguments.length; i++) {
            let lArgValue = '';
            if(arguments[i] != null){
                lArgValue = arguments[i].toString();
            }
            let lRegExp = new RegExp('\\{' + i.toString() + '\\}', 'g');
            lResult = lResult.replace(lRegExp, lArgValue)
        }

        // clear any format tag left
        let lRegExp = /\{\d+\}/g;
        lResult = lResult.replace(lRegExp,'');

        return lResult;
    }
}

if(typeof String.prototype.capitalize === 'undefined'){

    String.prototype.capitalize = function($allWords){
        $allWords = $allWords==undefined ? false : $allWords;

        const lSegments = $allWords ? this.split(' ') : [this];
        const lResult = lSegments
                            .map(function($s){
                                return $s.substr(0,1).toUpperCase() + $s.substr(1);
                            })
                            .join(' ');
        return lResult;
    }

}

if(typeof String.prototype.toCamelCase === 'undefined'){
    String.prototype.toCamelCase = function(){
        const lStr = this.replace(/-|_/g,' ');
        const lSegments = lStr.split(' ');
        const lResult = lSegments
                            .map(function($s,$index){
                                $s = $s.toLowerCase();
                                if($index > 0){
                                    return $s.substr(0,1).toUpperCase() + $s.substr(1);
                                }
                                return $s;
                            });

        return lResult.join('');
    }
}

if(typeof String.prototype.trimChar === 'undefined'){
    String.prototype.trimChar = function($char){
        const lTrimRegex = new RegExp('^' + $char + '+|' + $char + '+$','g');
        const lStr = this.replace(lTrimRegex, '');
        return lStr;
    }
}


if(typeof String.prototype.sanitize === 'undefined'){
    String.prototype.sanitize = function(){
        const lLower = this.toLowerCase();
        const lRemoveAccent = lLower.normalize("NFD").replace(/\p{Diacritic}/gu, "");
        const lRemovePunctuation = lRemoveAccent.replace(/('|"|:)/g,'');
        const lNormalize = lRemovePunctuation.replace(/(\s)/g,'-');
        return lNormalize;
    }
}

if(typeof String.translate === 'undefined'){
    var $locales = {};
    (function locales($scope){
        $scope.supported_languages = [];
        $scope._current_lang_ = '';
        $scope.file_path = '';

        $scope.init = function($used_language){
            console.log('$locales/init', $used_language);
            // create language containers
            if(moment != undefined){
                moment.locale($used_language);
            }
            $scope._current_lang_ = $used_language;
        }

        $scope.load = function($files,$domain){
            if(!Array.isArray($files.push)){
                $files = [$files];
            }

            if(typeof $domain == 'undefined'){
                $domain = 'global';
            }

            if($scope[$scope._current_lang_]==undefined) {
                $scope[$scope._current_lang_]={};
                $scope.supported_languages.push($scope._current_lang_);
            }

            $files.forEach(function($f){
                $scope.loadJSON($f, function($response){
                    $scope[$scope._current_lang_][$domain] = $scope.merge_data($scope[$scope._current_lang_][$domain], $response);
                    const lKeyCount = Object.keys($response).length;
                    console.log(lKeyCount, 'language definition added to', $scope._current_lang_, $domain);
                });
            });
        }


        $scope.add = function($lang, $def, $domain){
            $domain = (typeof ($domain) == 'undefined') ? 'global' : $domain;
            if($scope[$lang]==undefined) {
                $scope[$lang]={};
                $scope.supported_languages.push($lang);
            }

            $scope[$lang][$domain] = $scope.merge_data($scope[$lang][$domain],$def);
            const lKeyCount = Object.keys($def).length;
            console.log(lKeyCount, 'language definition added to', $lang, $domain);
        }

        $scope.merge_data = function(obj1,obj2){
            var obj3 = {};
            for (var attrname in obj1) { obj3[attrname] = obj1[attrname]; }
            for (var attrname in obj2) { obj3[attrname] = obj2[attrname]; }
            return obj3;
        }

        $scope.loadJSON = function(filePath, success, error){
            let xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function()
            {
                if (xhr.readyState === XMLHttpRequest.DONE) {
                    if (xhr.status === 200) {
                        if (success)
                            // var lData = '';
                            // eval('lData = ' + xhr.responseText);
                            // success(lData);
                            success(JSON.parse(xhr.responseText));
                } else {
                    if (error)
                        error(xhr);
                    }
                }
            };
            xhr.open("GET", filePath, true);
            xhr.send();
        }
    })($locales);

    /**
     * Translate string using $locales datasheet
     * @param {string} $domain Optional. Domain in which to search for localized string
     * @param {string} $lang Optional. Forced lang to localize
     */
    String.prototype.translate = function ($domain, $lang) {
        if ($locales != undefined) {
            $domain = (typeof ($domain) == 'undefined') ? 'global' : $domain;
            $lang = (typeof ($lang) == 'undefined') ? $locales._current_lang_ : $lang;
            $key = this.toString();
            if ($lang in $locales) {
                if ($domain in $locales[$lang]) {
                    if ($key in $locales[$lang][$domain]) {
                        //console.log($key, 'found in ',$locales[$lang][$domain])
                        return $locales[$lang][$domain][$key];
                    }
                }
                else if ($key in $locales[$lang]){
                    //console.log($key, 'found in ',$locales[$lang])
                    return $locales[$lang][$key];
                }
                else{
                    //console.log('"',$key,'" not found in', $lang, 'or', $domain, $locales[$lang][$domain], $locales[$lang],$locales);
                }
            }
        }
        else{
            console.log('$locales is undefined');
        }
    
        return $key;
    }

}