
if(typeof Array.prototype.first === 'undefined'){
    Array.prototype.first = function($default=''){
        if(this.length == 0) return $default;
        return this[0];
    }
}
if(typeof Array.prototype.last === 'undefined'){
    Array.prototype.last = function($default=''){
        if(this.length == 0) return $default;
        return this[this.length-1];
    }
}

if(typeof Array.prototype.random === 'undefined'){
    Array.prototype.random = function(){
        const index = Math.min(Math.floor(Math.random() * this.length), this.length-1);
        console.log('Array.random', index);
        return this[index];
    }
}
if(typeof Array.prototype.takeRandom === 'undefined'){
    Array.prototype.takeRandom = function(min=0, max=undefined){
        if(max == undefined) max = this.length;
        max = Math.min(max, this.length);
        const count = min + Math.min(Math.floor(Math.random() * max), max);

        const result = this.filter( (e,i) => i<count);
        console.log('takeRandom',result);
        return result;
    }
}

if(typeof String.prototype.format === 'undefined'){
    
    String.prototype.format = function(){
        let lResult = this.toString();
        for (var i = 0; i < arguments.length; i++) {
            let lArgValue = '';
            if(arguments[i] != null){
                lArgValue = arguments[i].toString();
            }
            let lRegExp = new RegExp('\\{' + i.toString() + '\\}', 'g');
            lResult = lResult.replace(lRegExp, lArgValue);

            if(!isNaN(lArgValue)){
                
                const isPlural = parseInt(lArgValue) > 1;
                const expression = '\\{' + i.toString() + '\\$:(\\w+\\/?\\w*)\\}';
                
                const lPluralRegExp = new RegExp(expression, 'g');
                lResult = lResult.replace(lPluralRegExp, (m,g) => {
                    let pluralForm = '', singularForm = '';
                    
                    if(g.indexOf('/') >= 0){
                        [singularForm, pluralForm] = g.split('/');
                    }
                    else{
                        pluralForm = g;
                    }
    
                    if(isPlural) return pluralForm;
                    return singularForm;
                });
                
            }
        }

        // clear any format tag left
        let lRegExp = /\{\d{1,3}\$:(.+)\}/g;
        lResult = lResult.replace(lRegExp,'');
    
        lRegExp = /\{\d{1,3}\}/g;
        lResult = lResult.replace(lRegExp,'');

        return lResult;
    }
}

if(typeof String.prototype.capitalize === 'undefined'){

    String.prototype.capitalize = function($allWords){
        $allWords = $allWords==undefined ? false : $allWords;

        const lSegments = $allWords ? this.split(' ') : [this];
        const lResult = lSegments
                            .map(function($s){
                                return $s.substr(0,1).toUpperCase() + $s.substr(1);
                            })
                            .join(' ');
        return lResult;
    }

}

if(typeof String.prototype.toCamelCase === 'undefined'){
    String.prototype.toCamelCase = function(){
        const lStr = this.replace(/-|_/g,' ');
        const lSegments = lStr.split(' ');
        const lResult = lSegments
                            .map(function($s,$index){
                                $s = $s.toLowerCase();
                                if($index > 0){
                                    return $s.substr(0,1).toUpperCase() + $s.substr(1);
                                }
                                return $s;
                            });

        return lResult.join('');
    }
}

if(typeof String.prototype.trimChar === 'undefined'){
    String.prototype.trimChar = function($char){
        const lTrimRegex = new RegExp('^' + $char + '+|' + $char + '+$','g');
        const lStr = this.replace(lTrimRegex, '');
        return lStr;
    }
}


if(typeof String.prototype.sanitize === 'undefined'){
    String.prototype.sanitize = function(){
        const lLower = this.toLowerCase();
        const lRemoveAccent = lLower.normalize("NFD").replace(/\p{Diacritic}/gu, "");
        const lRemovePunctuation = lRemoveAccent.replace(/('|"|:)/g,'');
        const lNormalize = lRemovePunctuation.replace(/(\s)/g,'-');
        return lNormalize;
    }
}